#ifndef SWIG_LIBWCCL_MATCH_I
#define SWIG_LIBWCCL_MATCH_I

%module libcclbool
%{
  #include <libwccl/values/value.h>
  #include <libwccl/values/match.h>
%}

%include "std_string.i"
%include "libcclvalue.i"
%include "libcclposition.i"
// %include "libcclmatchdata.i"
// %include "libccltokenmatch.i"
%include "libcorpus/libcorpusannotatedsentence.i"

%feature("notabstract") Wccl::Match;

namespace Wccl {
  // class MatchData;

  class Match : public Value {
  public:
    const char* get_type_name() const { return type_name; }
    static std::string var_repr(const std::string &var_name);
    std::string make_var_repr(const std::string &var_name) const {
      return var_repr(var_name);
    }

    Match();
    // Match(const boost::shared_ptr<MatchData>& data);
    // Match(const boost::shared_ptr<TokenMatch>& data);
    // Match(const boost::shared_ptr<AnnotationMatch>& data);
    // Match(const boost::shared_ptr<MatchVector>& data);

    // Match(const MatchData& data);
    // Match(const Match& match);

    // %rename(MatchEq) operator=(const Match& match);
    // Match& operator=(const Match& match);

    // const MatchData& get_value() const;
    // MatchData& get_value();

    // void set_value(const MatchData& m);
    // bool empty() const;

    // virtual Position first_token(const boost::shared_ptr<Corpus2::AnnotatedSentence>&) const;
    // virtual Position last_token(const boost::shared_ptr<Corpus2::AnnotatedSentence>&) const;

    // std::string to_raw_string() const;
  };
}

using namespace std;
using namespace Wccl;

#endif /* SWIG_LIBWCCL_MATCH_I */
